package server

import (
	"github.com/nats-io/nats.go"
	"github.com/nats-io/nats.go/micro"
)

type Server struct {
	nc  *nats.Conn
	svc micro.Service
}

func eventHandler(req micro.Request) {
	req.Data()
}

func New(nc *nats.Conn) (*Server, error) {
	svc, err := micro.AddService(nc, micro.Config{
		Name:        "EventService",
		Version:     "1.0.0",
		Description: "falcon event service",
		Endpoint: &micro.EndpointConfig{
			Subject: "svc.event",
			Handler: micro.HandlerFunc(eventHandler),
		},
	})
	if err != nil {
		return nil, err
	}
	return &Server{
		nc:  nc,
		svc: svc,
	}, nil
}
